﻿using System;
using System.Collections.Generic;
using System.Linq;
using Windows.UI;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Documents;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;

// “用户控件”项模板在 http://go.microsoft.com/fwlink/?LinkId=234235 上有介绍

namespace G.Controls
{
    public sealed class Star : Control
    {
        public Star()
        {
            this.DefaultStyleKey = typeof(Star);
            this.SizeChanged += new SizeChangedEventHandler(Star_SizeChanged);
        }

        void Star_SizeChanged(object sender, SizeChangedEventArgs e)
        {
            double scaleX = e.NewSize.Width / 34;
            double scaleY = e.NewSize.Height / 34;
            //scaleTransform.ScaleX = scaleTransform.ScaleY = Math.Min(scaleX, scaleY);
        }

        #region StarFillBrushProperty
        public static readonly DependencyProperty StarFillBrushProperty = DependencyProperty.Register(
    "StarFillBrush", typeof(Brush),
    typeof(Star), new PropertyMetadata(new SolidColorBrush(Color.FromArgb(0xFF, 0xee, 0x77, 0x00))));

        public Brush StarFillBrush
        {
            get { return (Brush)GetValue(StarFillBrushProperty); }
            set { SetValue(StarFillBrushProperty, value); }
        }

        #endregion

        #region HalfFillBrushProperty
        public static readonly DependencyProperty HalfFillBrushProperty = DependencyProperty.Register(
    "HalfFillBrush", typeof(Brush),
    typeof(Star), new PropertyMetadata(null));

        public Brush HalfFillBrush
        {
            get { return (Brush)GetValue(HalfFillBrushProperty); }
            set { SetValue(HalfFillBrushProperty, value); }
        }

        #endregion

        #region StrokeThicknessProperty
        public static readonly DependencyProperty StrokeThicknessProperty = DependencyProperty.Register(
    "StrokeThickness", typeof(double),
    typeof(Star), new PropertyMetadata(2.0));

        public double StrokeThickness
        {
            get { return (double)GetValue(StrokeThicknessProperty); }
            set { SetValue(StrokeThicknessProperty, value); }
        }

        #endregion

        #region StrokeLineJoinProperty
        public static readonly DependencyProperty StrokeLineJoinProperty = DependencyProperty.Register(
    "StrokeLineJoin", typeof(PenLineJoin),
    typeof(Star), new PropertyMetadata(PenLineJoin.Round));

        public PenLineJoin StrokeLineJoin
        {
            get { return (PenLineJoin)GetValue(StrokeLineJoinProperty); }
            set { SetValue(StrokeLineJoinProperty, value); }
        }

        #endregion
    }
}
